"use strict";

const gateway = require("../services/handlerService");
const processfake = require("../fixtures/process_fake_00");


// serverless-moleculer
const {
    LambdaGateway,
    Handler
} = require("../../");

describe("Test Handler", () => {

	const env = Object.assign({}, process.env);

    it("should be created", () => {
        const handler = Handler(gateway);
        expect(handler).toBeDefined();
    });

    it("should be 10", () => {
    	// This is important
   		process.env.AWS_LAMBDA_FUNCTION_NAME = processfake.env.lambda_math_add_name;
   		process.env.IS_LOCAL = true;
   		process.env.SLS_DEBUG = "*";

        const handler = Handler(gateway);

        // This is what AWS see
        handler({
        		headers: {
        			"x-api-key": "moleculer-is-great"
        		},
        		// source: 'serverless-plugin-warmup',
                body: {
                    a: 5,
                    b: 5
                }
            }, {

            },
            (error, response) => {
            	console.log("@unittest - error", error);
            	console.log("@unittest - response", response);
                expect(error).toBeNull();
                expect(response).toBeDefined();
            }
        );
    });

});
